%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%If do not use the parallel algarithm, need to change parfor loop to for
%inputs: n the sample size; u a postive value; 
%kn: bandwidth in computing local volatility in Local Gaussian Bootstrap
%outputs: covererage rates for CLT,MW,GM,WL,LGB
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Re=Model1(n,u,kn)
CP=zeros(1,9);m=10000;
%matlabpool open 
parfor k=1:m
    clc;
    k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%Put the model code here%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%  Model 1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tau=zeros(n,1);w=randn(n-1,1)/sqrt(n);
for i=2:n
    tau(i,1)=tau(i-1,1)-0.025*tau(i-1,1)/n+w(i-1);
end
sigma=exp(0.3125-0.125*tau);
DN=poissrnd(4/n,n,1);DJ=zeros(n,1);
for i=1:n
    if DN(i,1)~=0
       DJ(i,1)=sum(0.1*randn(DN(i,1),1));
    end
end
DX=0.03/n+sigma.*randn(n,1)/sqrt(n)+0.1*DJ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
LT=mean(exp(-u*sigma.^2));
xi=cos(sqrt(2*u)*sqrt(n)*DX);
%%%%%%%%%%%%%%%%% CLT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RLT=mean(xi);
CT=(xi(1:n-1)-xi(2:n))'*(xi(1:n-1)-xi(2:n))/(2*n);
CIl=RLT-1.96*sqrt(1/n)*sqrt(CT);
CIu=RLT+1.96*sqrt(1/n)*sqrt(CT);
CLT=(CIl<=LT)*(LT<=CIu);
%%%%%%%%%%%%%%%%%%  MW %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Bm=999;
etaB0=1/sqrt(2)*randn(n-1,Bm);
RLTB0=(xi(2:n)'*ones(n-1,Bm)+(xi(1:n-1)-xi(2:n))'*etaB0+xi(n)*ones(1,Bm))/n;
SB0=sqrt(n)*abs(RLTB0-(sum(xi(2:n))+xi(n))/n);
CTB0=((xi(1:n-1)-xi(2:n)).^2)'*(etaB0.^2)/(n-1);TB0=SB0./sqrt(CTB0);
q0=quantile(SB0,0.95);q0t=quantile(TB0,0.95);
BCIl0=RLT-sqrt(1/n)*q0;BCIu0=RLT+sqrt(1/n)*q0;
BCIl0t=RLT-sqrt(1/n)*q0t*sqrt(CT);BCIu0t=RLT+sqrt(1/n)*q0t*sqrt(CT);
MW=(BCIl0<=LT)*(LT<=BCIu0);
MWt=(BCIl0t<=LT)*(LT<=BCIu0t);
%%%%%%%%%%%%%%%%%%  GM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Bm=999;
etaB=1/sqrt(2)*randn(n,Bm);
RLTBGM=xi'*etaB/n;
SB1=sqrt(n)*abs(RLTBGM);
q1=quantile(SB1,0.95);
BCIl1=RLT-sqrt(1/n)*q1;BCIu1=RLT+sqrt(1/n)*q1;
TB1=sqrt(n)*SB1./sqrt(xi'*xi/2);
q1t=quantile(TB1,0.95);
BCIl1t=RLT-sqrt(1/n)*q1t*sqrt(CT);BCIu1t=RLT+sqrt(1/n)*q1t*sqrt(CT);
GM=(BCIl1<=LT)*(LT<=BCIu1);
GMt=(BCIl1t<=LT)*(LT<=BCIu1t);
%%%%%%%%%%%%%%%%%%  WL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RLTBWL=RLT+(xi-RLT)'*etaB/n;
SB2=sqrt(n)*abs(RLTBWL-RLT);
q2=quantile(SB2,0.95);
BCIl2=RLT-sqrt(1/n)*q2;BCIu2=RLT+sqrt(1/n)*q2;
CTB2=xi'*xi/n-RLT^2;TB2=SB2./sqrt(CTB2/2);q2t=quantile(TB2,0.95);
BCIl2t=RLT-sqrt(1/n)*q2t*sqrt(CT);BCIu2t=RLT+sqrt(1/n)*q2t*sqrt(CT);
WL=(BCIl2<=LT)*(LT<=BCIu2);
WLt=(BCIl2t<=LT)*(LT<=BCIu2t);
%%%%%%%%%%%%%%    LGB   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NDX=reshape(DX,kn,n/kn);
BVD=NDX(1:kn-1,:).*NDX(2:kn,:);BV=pi/2*sum(abs(BVD),1)*n/kn;BVT=repmat(BV,kn,1);
lovi=NDX.^2.*(abs(NDX)<7*sqrt(BVT)*(1/n)^0.4);
chat=sum(lovi,1)*n/kn;chatn=reshape(repmat(chat,kn,1),n,1);
etaBL=randn(n,Bm);
SBL=zeros(Bm,1);TBL=zeros(Bm,1);TBLA=zeros(Bm,1);TBLA2=zeros(Bm,1);
for j=1:Bm
  xiBL=cos(sqrt(2*u*chatn).*etaBL(:,j));
  RLTBL=mean(xiBL);
  SBL(j,1)=sqrt(n)*abs(RLTBL-mean(exp(-u*chatn)));
  VB=xiBL-exp(-u*chatn);
  CTBL=VB'*VB/n;
  TBL(j,1)=SBL(j,1)/sqrt(CTBL);
  A1=exp(-u*chatn(1,1))+exp(-u*chatn(n,1));
  A2=2+exp(-4*u*chatn(1,1))+exp(-4*u*chatn(n,1));
  CTBLA=CTBL+sqrt(1/n)*(A1/2-A2/4);
  TA=1/2*sqrt(1/n)*(exp(-u*chatn(n,1))-exp(-u*chatn(1,1)))/sqrt(CTBLA);
  TBLA(j,1)=abs(sqrt(n)*(RLTBL-mean(exp(-u*chatn)))/sqrt(CTBLA)-TA);
  TA2=1/2*sqrt(1/n)*(exp(-u*chatn(n,1))-exp(-u*chatn(1,1)))/sqrt(CTBL);
  TBLA2(j,1)=abs(sqrt(n)*(RLTBL-mean(exp(-u*chatn)))/sqrt(CTBL)-TA2);
end
qL=quantile(SBL,0.95);qLt=quantile(TBL,0.95);
LBCIl=RLT-sqrt(1/n)*qL;LBCIu=RLT+sqrt(1/n)*qL;
LBCIlt=RLT-sqrt(1/n)*qLt*sqrt(CT);
LBCIut=RLT+sqrt(1/n)*qLt*sqrt(CT);
LGB=(LBCIl<=LT)*(LT<=LBCIu);
LGBt=(LBCIlt<=LT)*(LT<=LBCIut);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CP=CP+[CLT MW MWt GM GMt WL WLt LGB LGBt];
end
%matlabpool close
Re=100*CP/m;